<template>
  <b-modal ref="theModal" :title="modalTitle" size="lg" hide-footer>
    <div v-html="displayValue"></div>
  </b-modal>
</template>

<script>
export default {
  data() {
    return {
      displayValue: '',
    };
  },
  computed: {
    modalTitle() {
      let title = 'Preview:';
      if (this.brick) {
        title = title + ' ' + this.brick.definition.key;
      }

      return title;
    },
  },
  methods: {
    show(brick, mode, overrideValue) {
      let value = '#error#';

      if (overrideValue) {
        value = overrideValue;
      } else if (mode === 'source') {
        if (brick.sourceNext) {
          value = brick.sourceNext.value;
        } else if (brick.sourceDist) {
          value = brick.sourceDist.value;
        }
      } else if (brick.targetNext) {
        value = brick.targetNext.value;
      } else if (brick.targetDist) {
        value = brick.targetDist.value;
      }

      if (brick.definition.type === 'MARKDOWN') {
        this.displayValue = this.$marked(value);
      } else {
        this.displayValue = value;
      }

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
  },
};
</script>
